import React from 'react';
import { NativeProps } from '../../utils/native-props';
import { GetContainer } from '../../utils/render-to-container';
export declare type Action = {
    key: string | number;
    text: string;
    disabled?: boolean;
    description?: string;
    danger?: boolean;
    onClick?: () => void;
};
export declare type ActionSheetProps = {
    visible: boolean;
    actions: Action[];
    extra?: React.ReactNode;
    cancelText?: React.ReactNode;
    onAction?: (action: Action, index: number) => void;
    onClose?: () => void;
    afterClose?: () => void;
    onMaskClick?: () => void;
    closeOnAction?: boolean;
    closeOnMaskClick?: boolean;
    getContainer?: GetContainer;
} & NativeProps;
export declare const ActionSheet: React.FC<ActionSheetProps>;
export declare type ActionSheetRef = {
    close: () => void;
};
export declare function showActionSheet(props: Omit<ActionSheetProps, 'visible'>): {
    close: () => void;
};
