import React from 'react';
import { NativeProps } from '../../utils/native-props';
declare type NativeInputProps = React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
declare type EnterKeyHintProps = NativeInputProps extends {
    enterKeyHint?: unknown;
} ? {
    enterKeyHint?: NativeInputProps['enterKeyHint'];
} : {};
export declare type InputProps = Pick<NativeInputProps, 'maxLength' | 'minLength' | 'max' | 'min' | 'autoComplete' | 'pattern' | 'type' | 'onFocus' | 'onBlur' | 'autoCapitalize' | 'autoCorrect' | 'onKeyDown' | 'onKeyUp'> & EnterKeyHintProps & {
    value?: string;
    defaultValue?: string;
    onChange?: (val: string) => void;
    placeholder?: string;
    disabled?: boolean;
    readOnly?: boolean;
    clearable?: boolean;
    onClear?: () => void;
    id?: string;
    onEnterPress?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
} & NativeProps<'--font-size' | '--color' | '--placeholder-color' | '--disabled-color'>;
export declare type InputRef = {
    clear: () => void;
    focus: () => void;
    blur: () => void;
};
export declare const Input: React.ForwardRefExoticComponent<Pick<React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>, "pattern" | "max" | "min" | "type" | "onFocus" | "onBlur" | "onKeyDown" | "onKeyUp" | "autoCapitalize" | "autoCorrect" | "autoComplete" | "maxLength" | "minLength"> & {
    enterKeyHint?: React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>["enterKeyHint"] | undefined;
} & {
    value?: string | undefined;
    defaultValue?: string | undefined;
    onChange?: ((val: string) => void) | undefined;
    placeholder?: string | undefined;
    disabled?: boolean | undefined;
    readOnly?: boolean | undefined;
    clearable?: boolean | undefined;
    onClear?: (() => void) | undefined;
    id?: string | undefined;
    onEnterPress?: ((e: React.KeyboardEvent<HTMLInputElement>) => void) | undefined;
} & NativeProps<"--font-size" | "--color" | "--placeholder-color" | "--disabled-color"> & React.RefAttributes<InputRef>>;
export {};
