import classNames from 'classnames';
import React from 'react';
import { withNativeProps } from '../../utils/native-props';
import { useShouldRender } from '../../utils/use-should-render';
var classPrefix = "adm-dropdown-item";

var Item = function Item(props) {
  var _classNames;

  var cls = classNames(classPrefix, (_classNames = {}, _classNames[classPrefix + "-active"] = props.active, _classNames[classPrefix + "-highlight"] = props.highlight, _classNames));
  return withNativeProps(props, /*#__PURE__*/React.createElement("div", {
    className: cls,
    onClick: props.onClick
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-title"
  }, /*#__PURE__*/React.createElement("span", null, props.title))));
};

export default Item;
export var ItemChildrenWrap = function ItemChildrenWrap(props) {
  var _classNames2;

  var _props$active = props.active,
      active = _props$active === void 0 ? false : _props$active;
  var shouldRender = useShouldRender(active, props.forceRender, props.destroyOnClose);
  var cls = classNames(classPrefix + "-content", (_classNames2 = {}, _classNames2[classPrefix + "-content-hidden"] = !active, _classNames2));
  return shouldRender ? /*#__PURE__*/React.createElement("div", {
    className: cls,
    onClick: props.onClick
  }, props.children) : null;
};